#if !defined(_MSTL)
#define _MSTL

// ********************************

#include "messages.h"			       

#include "errors2.h"
#include "linear algebra errors.h"
#include "interpolation errors.h"

// ********************************

#include "algorithm2.h"
#include "bitset2.h"
#include "expression.h"	
#include "functional2.h"	
#include "miscellaneous functions.h"
#include "sort.h"		   
#include "stdarg2.h"
#include "template array.h"

// *****

#include "math2.h"
#include "number.h"

// *****

#include "column and row vectors.h"
#include "mmatrix.h"
#include "linear algebra.h"
#include "mvector.h"

#include "algorithm3.h"
#include "complex2.h"
#include "derivative.h"
#include "ode.h"
#include "interpolation.h"
#include "polynomial.h"
#include "roots.h"
#include "runge kutta.h"
#include "special functions.h"

// *****

#include "interpolation data.h"
//#include "interpolation base.h"
#include "discontinuous.h"

// *****

#include "units and constants.h"

// ********************************
// ********************************
// ********************************
// Member Function Templates

#include "errors2 member templates.cpp"
#include "expression member templates.cpp"
#include "template array member templates.cpp"

#include "column and row vectors member templates.cpp"
#include "mmatrix member templates.cpp"
#include "mvector member templates.cpp"

#include "interpolation data member templates.cpp"
//#include "discontinuous member templates.cpp"

// ********************************
// Function Templates

#include "algorithm2 function templates.cpp"
#include "miscellaneous functions templates.cpp"
#include "sort function templates.cpp"
#include "template array function templates.cpp"

#include "math2 function templates.cpp"

#include "linear algebra function templates.cpp"
#include "mvector function templates.cpp"

#include "complex2 templates.cpp"
#include "interpolation templates.cpp"
#include "ode templates.cpp"
#include "polynomial templates.cpp"
#include "roots templates.cpp"
#include "runge kutta templates.cpp"

//#include "interpolation base function templates.cpp"
//#include "discontinuous function templates.cpp" 

// ********************************

#endif
